package cn.com.tenlion.systembase.util.fullsync;

import cn.com.tenlion.systembase.pojo.dtos.school.SchoolDTO;
import cn.com.tenlion.systembase.pojo.dtos.stuteasafe.StuTeaSafeDTO;
import cn.com.tenlion.systembase.pojo.vos.stuteasafe.StuTeaSafeVO;
import cn.com.tenlion.systembase.service.school.ISchoolService;
import cn.com.tenlion.systembase.service.stuteasafe.IStuTeaSafeService;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.exceptions.SearchException;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表单全量数据同步
 * 接收数据整合系统发来的全量数据同步命令, 向数据整合系统发送表单的全部数据
 */
@Component
public class FullSyncC0017 implements ApplicationEventPublisherAware {

    private ApplicationEventPublisher applicationEventPublisher;
    @Autowired
    private IStuTeaSafeService stuTeaSafeService;
    @Autowired
    private ISchoolService schoolService;
    @Autowired
    KafkaTemplate kafkaTemplate;

    public FullSyncC0017() {}

    @KafkaListener(topics = "C0017FullSync")
    public void message(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        System.out.println(jsonObject.toJSONString());// 表单编号
        System.out.println(jsonObject.getString("tableNumber"));// 表单编号
        System.out.println(jsonObject.getInteger("tableDataCount"));// 整合系统数据量
        /**
         * 1 . 查询本地数据的数量 , 如果本地数据量 > 整合系统数据量
         * 2 . 查询数据库中所有的事件列表
         * 3 . 遍历事件, 封装数据
         * 4 . 发送新增案件消息
         */
        Map<String, Object> params = new HashMap<>();
        List<StuTeaSafeDTO> stuTeaSafeDTOList = stuTeaSafeService.list(params);
        System.out.println(stuTeaSafeDTOList.size());
        if(null != stuTeaSafeDTOList && stuTeaSafeDTOList.size() > 0) {
            for(StuTeaSafeDTO stuTeaSafeDTO: stuTeaSafeDTOList) {
                SchoolDTO schoolDTO = schoolService.get(stuTeaSafeDTO.getSchoolId());
                StuTeaSafeVO stuTeaSafeVO = setData(stuTeaSafeDTO, schoolDTO);
                stuTeaSafeService.saveKafka(stuTeaSafeDTO.getStuTeaSafeId(), stuTeaSafeVO);
            }
        }
    }

    @KafkaListener(topics = "C0017")
    public void messageMsg(ConsumerRecord<?, ?> record) {
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        Map<String, Object> params = new HashMap<>();
        if(!"delete".equals(jsonObject.getString("action"))) {
            StuTeaSafeDTO stuTeaSafeDTO = stuTeaSafeService.get(jsonObject.getString("uid"));
            SchoolDTO schoolDTO = schoolService.get(stuTeaSafeDTO.getSchoolId());
            StuTeaSafeVO stuTeaSafeVO = setData(stuTeaSafeDTO, schoolDTO);
            stuTeaSafeService.saveKafka(stuTeaSafeDTO.getStuTeaSafeId(), stuTeaSafeVO);
        }else {
            stuTeaSafeService.deleteKafka(jsonObject.getString("uid"));
        }
    }

    private StuTeaSafeVO setData(StuTeaSafeDTO stuTeaSafeDTO, SchoolDTO schoolDTO) {
        if(null == stuTeaSafeDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        StuTeaSafeVO stuTeaSafeVO = new StuTeaSafeVO();
        stuTeaSafeVO.setSchoolName(schoolDTO.getSchoolName());
        stuTeaSafeVO.setCaseCode(stuTeaSafeDTO.getCaseCode());
        stuTeaSafeVO.setCaseName(stuTeaSafeDTO.getCaseName());
        stuTeaSafeVO.setHappenTime(stuTeaSafeDTO.getHappenTime());
        stuTeaSafeVO.setHappenAddress(stuTeaSafeDTO.getHappenAddress());
        stuTeaSafeVO.setLongitude(stuTeaSafeDTO.getLongitude());
        stuTeaSafeVO.setLatitude(stuTeaSafeDTO.getLatitude());
        stuTeaSafeVO.setCaseNatureName(stuTeaSafeDTO.getCaseNatureName());
        stuTeaSafeVO.setCaseSituation(stuTeaSafeDTO.getCaseSituation());
        stuTeaSafeVO.setCaseSolve(stuTeaSafeDTO.getCaseSolve());
        stuTeaSafeVO.setCrimeCount(stuTeaSafeDTO.getCrimeCount());
        stuTeaSafeVO.setAtLargeCount(stuTeaSafeDTO.getAtLargeCount());
        stuTeaSafeVO.setArrestCount(stuTeaSafeDTO.getArrestCount());
        stuTeaSafeVO.setCaseSolve(stuTeaSafeDTO.getCaseSolve());
        stuTeaSafeVO.setHappenLocationCode(stuTeaSafeDTO.getHappenLocationCode());
        stuTeaSafeVO.setGrid(stuTeaSafeDTO.getGrid());
        return stuTeaSafeVO;
    }

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
        this.applicationEventPublisher = applicationEventPublisher;
    }

}